"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var TimeSlotUtils = _interopRequireWildcard(require("./utils/TimeSlots"));

var _TimeSlotGroup = _interopRequireDefault(require("./TimeSlotGroup"));

var TimeGutter = function TimeGutter(_ref) {
  var min = _ref.min,
      max = _ref.max,
      timeslots = _ref.timeslots,
      step = _ref.step,
      localizer = _ref.localizer,
      getNow = _ref.getNow,
      resource = _ref.resource,
      components = _ref.components,
      getters = _ref.getters,
      gutterRef = _ref.gutterRef;

  var _useState = (0, _react.useState)(TimeSlotUtils.getSlotMetrics({
    min: min,
    max: max,
    timeslots: timeslots,
    step: step,
    localizer: localizer
  })),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      slotMetrics = _useState2[0],
      setSlotMetrics = _useState2[1];

  (0, _react.useEffect)(function () {
    if (slotMetrics) {
      setSlotMetrics(slotMetrics.update({
        min: min,
        max: max,
        timeslots: timeslots,
        step: step,
        localizer: localizer
      }));
    }
    /**
     * We don't want this to fire when slotMetrics is updated as it would recursively bomb
     */
    // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [min, max, timeslots, step]);

  var renderSlot = function renderSlot(value, idx) {
    if (idx) return null; // don't return the first (0) idx

    var isNow = slotMetrics.dateIsInGroup(getNow(), idx);
    return /*#__PURE__*/_react.default.createElement("span", {
      className: (0, _clsx.default)('rbc-label', isNow && 'rbc-now')
    }, localizer.format(value, 'timeGutterFormat'));
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "rbc-time-gutter rbc-time-column",
    ref: gutterRef
  }, slotMetrics.groups.map(function (grp, idx) {
    return /*#__PURE__*/_react.default.createElement(_TimeSlotGroup.default, {
      key: idx,
      group: grp,
      resource: resource,
      components: components,
      renderSlot: renderSlot,
      getters: getters
    });
  }));
};

var _default = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  return /*#__PURE__*/_react.default.createElement(TimeGutter, Object.assign({
    gutterRef: ref
  }, props));
});

exports.default = _default;